      function lip(zin)
      double precision zin
      double complex lip
      
      if(zin < 0d0) then
        lip = log(-zin) + (0d0,3.141592653589793d0)
      else
        lip = log(zin)
      endif
      end
      
      function lim(zin)
      double precision zin
      double complex lim
      
      if(zin < 0d0) then
        lim = log(-zin) - (0d0,3.141592653589793d0)
      else
        lim = log(zin)
      endif
      end
      

      function li2(zin)
      double precision zin
      double complex li2
      double precision z, pow, add
      integer k
      
      if(zin > 0.5d0) then
        if(zin < 1d0) then
          li2 = 1.6449340668482262d0 - log(zin)*log(1d0-zin)
        elseif(zin > 1d0) then
          li2 = 1.6449340668482262d0 - log(zin)*
     +           (log(zin-1d0) + (0d0,3.141592653589793d0))
        else
          li2 = 1.6449340668482262d0
	  return
	endif
	z = 1d0-zin
	pow = -1d0
      else
        li2 = 0d0
	z = zin
        pow = 1d0
      endif
      if(z < -0.5d0) then
        li2 = li2 - pow * (0.5d0 * log(1-z)**2)
	z = -z/(1-z)
	pow = -pow
      endif
      do k=1,100
        pow = pow * z
	add = pow/k**2
	li2 = li2 + add
	if(abs(add) < abs(li2)*1d-16) return
      enddo
      write(0,*) 'dilog of', zin, ' does not converge!'
      stop      
      end
      

#include "fdef.f"

      subroutine integrand(ndim, x, ncomp, ff)
      implicit double complex (t)
      integer ndim, ncomp
      double precision x(*), ff(*)
      
      double complex y(NVAR), z(NVAR), jgm(NVAR,NVAR), jg, res(NCOMP)
      double complex abbv(20)
      integer i
      
#include "fvar.f"
      
#include "fint.f"
      do i=1,NCOMP
        ff(2*i-1) = realpart(res(i))
        ff(2*i)   = imagpart(res(i))
      enddo
      end


      Program fpint
      
      implicit double complex (t)

      external integrand
      double complex lip, lim, li2, ana(NCOMPA)
      integer npoints, neval, nregions, fail, i
      character intr
      double precision epsrel, epsabs, xb(10), xs(10)
      double precision integral(2*NCOMP), error(2*NCOMP), prob(2*NCOMP)
      real*4 time(2), timeold, timenew
      character*80 carg

#include "fvar.f"
#include "fvar2.f"

      call getarg(0,carg)
      i = len(carg)
      do while((carg(i:i) .ne. '/') .and. (i>1))
        i = i-1
      enddo
      epsabs = -1d0
      open(51, file=carg(1:i)//'runpar.sys', status='old', err=10)
      read(51,*,err=10,end=10) intr
      read(51,*,err=10,end=10) npoints
      read(51,*,err=10,end=10) epsrel
      read(51,*,err=10,end=10) epsabs
      close(51)
10    if(epsabs < 0) then
        write(0,*) "File runpar.sys not found or ill-formatted!"
	stop
      endif

#if NVAR==1
#define NVARC 2
#else
#define NVARC NVAR
#endif

      timeold = etime(time)
      if(intr .eq. 'c') then
        call cuhre(NVARC, 2*NCOMP, integrand, epsrel, epsabs, 0,0,npoints,
     +             1, nregions, neval, fail, integral, error, prob)
      elseif(intr .eq. 'v') then
        call vegas(NVAR, 2*NCOMP, integrand, epsrel, epsabs, 0,0,npoints,
     +             20000, 10000, neval, fail, integral, error, prob)
      else
        write(0,*) "Unknown integration method '", intr, "'!"
	stop
      endif
      timenew = etime(time)
#include "fana.f"
      do i=1,NCOMP
        write(*,*) complex(integral(2*i-1),integral(2*i)) + ana(i), 
     +	           complex(error(2*i-1), error(2*i)) 
      enddo
#if NCOMP<NCOMPA
      do i=NCOMP+1,NCOMPA
        if(ana(i) .ne. 0d0)  write(*,*) ana(i), complex(0d0,0d0)
      enddo
#endif
c      write(*,*) neval, prob(1), fail, timenew-timeold
      
      End
